/*
 * np-dps - spinlock.h
 *
 * Copyright (C) 2016  Krzysztof Mazur <krzysiek@podlesie.net>
 *
 * Based od Linux.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

#ifndef SPINLOCK_H_INCLUDED
#define SPINLOCK_H_INCLUDED

typedef struct { } raw_spinlock_t;
#define raw_spin_lock_init(lock)	do { (void)(lock); } while (0)
#define raw_spin_lock(lock)		do { barrier(); (void)(lock); } while (0)
#define raw_spin_is_locked(lock)	((void)(lock), 0)
#define raw_spin_trylock(lock)	({1; })
#define raw_spin_unlock_wait(lock)	do { barrier(); (void)(lock); } while(0)
#define raw_spin_unlock(lock)	do { barrier(); (void)(lock); } while(0)

#define __RAW_SPIN_LOCK_UNLOCKED(x) { }

#define DEFINE_RAW_SPINLOCK(x)	raw_spinlock_t x = __RAW_SPIN_LOCK_UNLOCKED(x)

typedef raw_spinlock_t spinlock_t;
#define spin_lock_init(lock)	do { (void)(lock); } while (0)
#define spin_lock(lock)		do { barrier(); (void)(lock); } while (0)
#define spin_is_locked(lock)	((void)(lock), 0)
#define spin_trylock(lock)	({1; })
#define spin_unlock_wait(lock)	do { barrier(); (void)(lock); } while(0)
#define spin_unlock(lock)	do { barrier(); (void)(lock); } while(0)

#define __SPIN_LOCK_UNLOCKED(x) { }

#define DEFINE_SPINLOCK(x)	spinlock_t x = __SPIN_LOCK_UNLOCKED(x)

#endif
